<?php

// $Id: urpmiweb.inc,v 1.3 2003/03/03 22:29:03 nanardon Exp $

// parse mirror list file
//return array of array
function parse_liste($file)
	{
	global $globinfo;
	
	$f=@fopen($file,r);
	if (!$f) return array();
	
	$thislist=array();
	$tempval=array();
	
	while ($line=fgets($f,4096))
		{
		$line = chop($line);
		if (strpos($line,'//')===0) {continue;}
		if (sscanf($line,'[%s]',$sec))
			{ $section=rtrim($sec,"]"); continue;}

		if ($section)
			{
			list($t['name'],$t['mdkver'],$t['arch'],$t['location'],$t['url'])=explode(':',$line,5);
			
			$t['_filesource']=$file; // For debugging purpose
			
			if ($t['name']=='$') $t['name']=$tempval['name'];
			if ($t['location']=='$') $t['location']=$tempval['location'];
			if ($t['mdkver']=='$') $t['mdkver']=$tempval['mdkver'];
			if ($t['arch']=='$') $t['arch']=$tempval['arch'];
			reset($tempval);
			while (list($key,$val)=each($tempval))
				{
				$t['name']=str_replace('${'.$key.'}',$val,$t['name']);
				$t['arch']=str_replace('${'.$key.'}',$val,$t['arch']);
				$t['mdkver']=str_replace('${'.$key.'}',$val,$t['mdkver']);
				}
			$t['name']=str_replace('$',$tempval['name'],$t['name']);
			$t['arch']=str_replace('$',$tempval['arch'],$t['arch']);
			$t['mdkver']=str_replace('$',$tempval['mdkver'],$t['mdkver']);
			$larch=explode('|',$t['arch']);
			$lname=explode('|',$t['name']);
			$lmdkver=explode('|',$t['mdkver']);
			
			foreach($larch as $tarch)
				foreach($lmdkver as $tmdkver)
					foreach($lname as $tname)
					{
					$tt=$t;
					$tt['arch']=$tarch;
					$tt['name']=$tname;
					$tt['mdkver']=$tmdkver;
					$thislist[]=$tt;
					} 
			}
		else
			{
			
			list($var,$val)=split('=',$line,2);
			if ($var[0]==':')
				{
				list($gvar,$gval)=split(':',$val,2);
				$globinfo[$var][$gvar] = $gval;
				}
			else
				$tempval[$var]=$val;
			}
		}
		
		foreach(array_keys($thislist) as $n)
			{
			$t=&$thislist[$n];
			
			
			reset($t);
			while (list($key,$val)=each($t))
				{
				if ($key != 'url') $t['url']=str_replace("$(".$key.")",$val,$t['url']);
				}
			reset($tempval);
			while (list($key,$val)=each($tempval))
				{
				$t['url']=str_replace('${'.$key.'}',$val,$t['url']);
				}
			reset($t);
			while (list($key,$val)=each($t))
				{
				if ($key != 'url') $t['url']=str_replace("$(".$key.")",$val,$t['url']);
				}
			$myurl=str_replace('::','/',$t['url']);
			$h=parse_url($myurl);
			$t['host']=$h['host'];
			$t['mach']=$h['scheme'].'://'.$h['host'];
			}

	return $thislist;
	}

// read one url
function readurl($url)
	{
	global $globinfo;
	$list=array();
	$purl=fopen($url,r);
	while ($line=fgets($purl,4096))
		{
		$entry=array();
		list($entry['name'],$entry['mdkver'],$entry['arch'],$entry['location'],$entry['url'])=split(':',$line,5);
		if ($entry['name']) {
			$turl=str_replace('::','/',$entry['url']);
			$mach=parse_url($turl);
			$entry['host']=$mach['host'];
			$entry['mach']=$mach['scheme'].'://'.$mach['host'];
			$entry['_filesource']=$url; //debugging purpose
			$list[]=$entry;
			}
		else
			{
			$globinfo[':'.$entry['arch']][$entry['location']]=$entry['url'];
			}
		}
	return $list;
	}

// read each files in mirror.list dir
function readfiles()
	{
	global $globinfo;
	$glist=array();
	$d=opendir('mirror.list');
	if ($d)
		{
		while (($file=readdir($d))!==false)
			{
			if ($file != '.' && $file != '..')
				{
				$list=parse_liste('mirror.list/'.$file);
				if (is_array($list)) {$glist=array_merge($glist,$list);}
				}
			}
		closedir($d);
		}

	// fix location of mirror from global info
	while (list($key,$val)=each($glist))
		{
		if ($globinfo[':location'][$val['host']]) $glist[$key]['location']=$globinfo[':location'][$val['host']];
		}
	if (is_array($globinfo[':getfromurl']))

	// retriving info from other site
	while (list($key,$val)=each($globinfo[':getfromurl']))
		{
		$glist=array_merge(readurl($val),$glist);
		}

	//removing non exitent ver/arch
	while (list($key,$val)=each($globinfo[':compat_va']))
		$compatva[$key]=split(',',$val);

	foreach (array_keys($glist) as $key)
		{
		if ($glist[$key]['arch'] == 'noarch' || $glist[$key]['arch'] =='*' ) continue;
		if (@in_array($glist[$key]['arch'],$compatva[$glist[$key]['mdkver']])===false) unset($glist[$key]);
		}

	return $glist;
}

?>
